this.name					= "stellarSerpents_bodySegment.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike.";
this.description			= "Script to control Serpent body segment";
this.version				= "1.00";
"use strict";

this.shipSpawned = function()
	{
	/*this.amplitudeX, this.amplitudeY, this.phase,
	this.offset and this.mother are all defined by the mother script which spawns this segment. */

	this.segCounter = 0;
	switch(this.phase) // so segments near the head don't oscillate as much
		{
		case(0):
			{
			this.amplitudeX *= 0.2;
			this.amplitudeY *= 0.2;
			break;
			}
		case(1):
			{
			this.amplitudeX *= 0.4;
			this.amplitudeY *= 0.4;
			break;
			}
		case(2):
			{
			this.amplitudeX *= 0.6;
			this.amplitudeY *= 0.6;
			break;
			}
		}
	this.callbackID = addFrameCallback(this.moveSegment.bind(this));
	}
	
this.moveSegment = function(delta)
	{
	if(this.mother && this.mother.isValid)
		{
		this.ship.scannerDisplayColor1 = [0,0,0,0];
		this.ship.position = this.mother.position.subtract(this.mother.vectorForward.multiply(275+(this.phase*140)));
		this.ship.orientation = this.mother.orientation;
		this.angleX = (Math.sin((clock.absoluteSeconds * Math.PI) + ((this.phase / 4) * Math.PI))); 
		this.angleY = (Math.sin((clock.absoluteSeconds * Math.PI) + (((this.phase + this.offset) / 4) * Math.PI))); 
		this.swingX = this.angleX * this.amplitudeX;
		this.swingY = this.angleY * this.amplitudeY;
		this.ship.position = this.ship.position.add(this.ship.vectorRight.multiply(this.swingX));
		this.ship.position = this.ship.position.add(this.ship.vectorUp.multiply(this.swingY));
		}
	else
		{
		this.freelance();
		}
	}
	
this.freelance = function()
	{
	this.ship.scannerDisplayColor1 = null;
	if(this.callbackID && isValidFrameCallback(this.callbackID))
		{ removeFrameCallback(this.callbackID); }
	this.ship.displayName = "Stellar Serpent Corpse Segment";
	}
	
this.shipBeingAttacked = function(whom)
	{
	if(this.mother && whom)
		{
		this.mother.target = whom;
		this.mother.reactToAIMessage("ATTACKED");
		}
	}
	
this.shipAttackedWithMissile = function(missile, whom)
	{
	if(this.mother && whom)
		{
		this.mother.target = whom;
		this.mother.reactToAIMessage("ATTACKED");
		}
	}
	

this.shipDied = this.shipRemoved = this.playerWillEnterWitchspace = function()
	{
	this.freelance();
	function siblings(entity) {return entity.isShip && entity.hasRole("stellarSerpents_body") && entity.script.mother && entity.script.mother == this.mother && entity.script.phase > this.phase}; 
	var segments = system.filteredEntities(this, siblings, this.ship, 5000); 
	
	if(segments.length > 0)
		{
		for(var looseCounter = 0;looseCounter<segments.length;looseCounter++)
			{ segments[looseCounter].script.freelance(); }
		}
	}