this.name					= "stellarSerpents_head.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike.";
this.description			= "Stellar Serpent set-up";
this.version				= "1.00";
"use strict";

this.shipSpawned = function()
	{
	this.phase = -1; // ensure the oscillation-stoppings of following segments when higher one is destroyed doesn't affect head.
	
	this.serpentType = Math.ceil(Math.random() * 4);
	switch(this.serpentType)
		{
		case 0:
		case 1: // horizontal oscillation only
			{
			this.amplitudeX = 50 + Math.ceil(Math.random() * 100);
			this.amplitudeY = 0;
			this.spawnBody();
			break;
			}
			
		case 2: // vertical oscillation only
			{
			this.amplitudeX = 0;
			this.amplitudeY = 50 + Math.ceil(Math.random() * 100);
			this.spawnBody();
			break;
			}
			
		case 3: // anti-clockwise rotation
			{
			this.amplitudeX = -50 - Math.ceil(Math.random() * 100);
			this.amplitudeY = 50 + Math.ceil(Math.random() * 100);
			this.spawnBody();
			break;
			}	
			
		case 4: //  clockwise rotation
			{
			this.amplitudeX = 50 + Math.ceil(Math.random() * 100);
			this.amplitudeY = 50 + Math.ceil(Math.random() * 100);
			this.spawnBody();
			break;
			}			
		}	
	}	

this.spawnBody = function()
	{
	this.offset = Math.ceil(2 * Math.random() * 16) - 8;	
	this.segmentCount = 8 + Math.ceil(Math.random() * 16); // between 9 and 24 segments to the serpent

	for(var spawnCounter = 0;spawnCounter<this.segmentCount;spawnCounter++)
		{
		if(spawnCounter == this.segmentCount - 1)
			{
			var section = this.ship.spawnOne("stellarSerpents_tail");
			}
		else
			{
			var section = this.ship.spawnOne("stellarSerpents_bodySegment");
			}
		section.script.phase = spawnCounter;	
		section.script.mother = this.ship;
		section.script.amplitudeX = this.amplitudeX;
		section.script.amplitudeY = this.amplitudeY;
		section.script.offset = this.offset;
		}
	}

this.shipDied = function(whom, why)
	{
	if(why && why == "removed") //  if the serpent was removed rather than killed
		{
		return;
		}
	
	missionVariables.stellarSerpents_status = "NO_SERPENT";
	mission.setInstructionsKey("stellarSerpents_shortNoSerpent", "stellarSerpents_masterScript.js");
	
	if(whom && (whom.isPlayer || (whom.owner && whom.owner.isPlayer) || whom.hasRole("hiredGuns_escort") || whom.hasRole("aquatics_guardianPlayer"))) // killed by player or their henchthings
		{
		missionVariables.stellarSerpents_notification = "PLAYER_DESTROYED";
		player.consoleMessage("500₢ awarded for Serpent termination.", 6)
		player.credits += 500;
		player.score += 1;
		}
	else
		{
		missionVariables.stellarSerpents_notification = "NPC_DESTROYED";
		}
	}